using MemoryPack;
using System.Runtime.InteropServices;

namespace Insight.Agent.Messages
{
    [MemoryPackUnion(90, typeof(OperationSystem))]
    public partial interface IAgentMessage { }

    [MemoryPackable]
    public partial class OperationSystem : IAgentMessage
    {
        [MemoryPackOrder(0)]
        public string? Name { get; set; }

        [MemoryPackOrder(1)]
        public string? Version { get; set; }

        [MemoryPackOrder(2)]
        public string? SerialNumber { get; set; }

        [MemoryPackOrder(3)]
        public Architecture? Architecture { get; set; }

        [MemoryPackOrder(4)]
        public bool? Virtual { get; set; }

        [MemoryPackOrder(5)]
        public DateTime? InstallDate { get; set; }
    }
}